# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2016_06_01
  module Models
    #
    # The Key Encryption Key (KEK) is the encryption key for the Bitlocker
    # Encryption Key (BEK).
    #
    class KEKDetails

      include MsRestAzure

      # @return [String] Key refers to the Key Encryption Key (KEK). The KEK is
      # the Key to unlock the Secret.
      attr_accessor :key_url

      # @return [String] Key Vault ID identifies where the KEK is stored.
      attr_accessor :key_vault_id

      # @return [String] Key Backup Data refers to Key Encryption Key (KEK)
      # data.
      attr_accessor :key_backup_data


      #
      # Mapper for KEKDetails class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'KEKDetails',
          type: {
            name: 'Composite',
            class_name: 'KEKDetails',
            model_properties: {
              key_url: {
                client_side_validation: true,
                required: false,
                serialized_name: 'keyUrl',
                type: {
                  name: 'String'
                }
              },
              key_vault_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'keyVaultId',
                type: {
                  name: 'String'
                }
              },
              key_backup_data: {
                client_side_validation: true,
                required: false,
                serialized_name: 'keyBackupData',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
