# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2016_06_01
  module Models
    #
    # Filters the list of backup items.
    #
    class ProtectedItemQueryObject

      include MsRestAzure

      # @return [BackupManagementType] The backup management type associated
      # with an item. Possible values include: 'Invalid', 'AzureIaasVM', 'MAB',
      # 'DPM', 'AzureBackupServer', 'AzureSql'
      attr_accessor :backup_management_type

      # @return [DataSourceType] The workload type associated with an item.
      # Possible values include: 'Invalid', 'VM', 'FileFolder', 'AzureSqlDb',
      # 'SQLDB', 'Exchange', 'Sharepoint', 'DPMUnknown'
      attr_accessor :item_type

      # @return [String] The name of the backup policy associated with the
      # item.
      attr_accessor :policy_name

      # @return [String] The name of the container.
      attr_accessor :container_name


      #
      # Mapper for ProtectedItemQueryObject class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ProtectedItemQueryObject',
          type: {
            name: 'Composite',
            class_name: 'ProtectedItemQueryObject',
            model_properties: {
              backup_management_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'backupManagementType',
                type: {
                  name: 'Enum',
                  module: 'BackupManagementType'
                }
              },
              item_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'itemType',
                type: {
                  name: 'Enum',
                  module: 'DataSourceType'
                }
              },
              policy_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'policyName',
                type: {
                  name: 'String'
                }
              },
              container_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'containerName',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
