# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2016_08_10
  module Models
    #
    # Class to represent shoebox log specification in json client discovery.
    #
    class ClientDiscoveryForLogSpecification

      include MsRestAzure

      # @return [String] Name for shoebox log specification.
      attr_accessor :name

      # @return [String] Localized display name
      attr_accessor :display_name

      # @return [String] blob duration of shoebox log specification
      attr_accessor :blob_duration


      #
      # Mapper for ClientDiscoveryForLogSpecification class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ClientDiscoveryForLogSpecification',
          type: {
            name: 'Composite',
            class_name: 'ClientDiscoveryForLogSpecification',
            model_properties: {
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              display_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'displayName',
                type: {
                  name: 'String'
                }
              },
              blob_duration: {
                client_side_validation: true,
                required: false,
                serialized_name: 'blobDuration',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
