# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2016_08_10
  module Models
    #
    # Available operation details.
    #
    class ClientDiscoveryValueForSingleApi

      include MsRestAzure

      # @return [String] Name of the Operation.
      attr_accessor :name

      # @return [ClientDiscoveryDisplay] Contains the localized display
      # information for this particular operation
      attr_accessor :display

      # @return [String] The intended executor of the operation;governs the
      # display of the operation in the RBAC UX and the audit logs UX
      attr_accessor :origin

      # @return [ClientDiscoveryForProperties] ShoeBox properties for the given
      # operation.
      attr_accessor :properties


      #
      # Mapper for ClientDiscoveryValueForSingleApi class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ClientDiscoveryValueForSingleApi',
          type: {
            name: 'Composite',
            class_name: 'ClientDiscoveryValueForSingleApi',
            model_properties: {
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              display: {
                client_side_validation: true,
                required: false,
                serialized_name: 'display',
                type: {
                  name: 'Composite',
                  class_name: 'ClientDiscoveryDisplay'
                }
              },
              origin: {
                client_side_validation: true,
                required: false,
                serialized_name: 'origin',
                type: {
                  name: 'String'
                }
              },
              properties: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties',
                type: {
                  name: 'Composite',
                  class_name: 'ClientDiscoveryForProperties'
                }
              }
            }
          }
        }
      end
    end
  end
end
