# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2016_12_01
  module Models
    #
    # Container identity information
    #
    class ContainerIdentityInfo

      include MsRestAzure

      # @return [String] Unique name of the container
      attr_accessor :unique_name

      # @return [String] Protection container identity - AAD Tenant
      attr_accessor :aad_tenant_id

      # @return [String] Protection container identity - AAD Service Principal
      attr_accessor :service_principal_client_id

      # @return [String] Protection container identity - Audience
      attr_accessor :audience


      #
      # Mapper for ContainerIdentityInfo class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ContainerIdentityInfo',
          type: {
            name: 'Composite',
            class_name: 'ContainerIdentityInfo',
            model_properties: {
              unique_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'uniqueName',
                type: {
                  name: 'String'
                }
              },
              aad_tenant_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'aadTenantId',
                type: {
                  name: 'String'
                }
              },
              service_principal_client_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'servicePrincipalClientId',
                type: {
                  name: 'String'
                }
              },
              audience: {
                client_side_validation: true,
                required: false,
                serialized_name: 'audience',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
