# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2016_12_01
  module Models
    #
    # Base class for generic container of backup items
    #
    class GenericContainer < ProtectionContainer

      include MsRestAzure


      def initialize
        @containerType = "GenericContainer"
      end

      attr_accessor :containerType

      # @return [String] Name of the container's fabric
      attr_accessor :fabric_name

      # @return [GenericContainerExtendedInfo] Extended information (not
      # returned in List container API calls)
      attr_accessor :extended_information


      #
      # Mapper for GenericContainer class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'GenericContainer',
          type: {
            name: 'Composite',
            class_name: 'GenericContainer',
            model_properties: {
              friendly_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'friendlyName',
                type: {
                  name: 'String'
                }
              },
              backup_management_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'backupManagementType',
                type: {
                  name: 'String'
                }
              },
              registration_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'registrationStatus',
                type: {
                  name: 'String'
                }
              },
              health_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'healthStatus',
                type: {
                  name: 'String'
                }
              },
              containerType: {
                client_side_validation: true,
                required: true,
                serialized_name: 'containerType',
                type: {
                  name: 'String'
                }
              },
              fabric_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'fabricName',
                type: {
                  name: 'String'
                }
              },
              extended_information: {
                client_side_validation: true,
                required: false,
                serialized_name: 'extendedInformation',
                type: {
                  name: 'Composite',
                  class_name: 'GenericContainerExtendedInfo'
                }
              }
            }
          }
        }
      end
    end
  end
end
