# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2016_12_01
  module Models
    #
    # Container with items backed up using MAB backup engine.
    #
    class MabContainer < ProtectionContainer

      include MsRestAzure


      def initialize
        @containerType = "Windows"
      end

      attr_accessor :containerType

      # @return [Boolean] Can the container be registered one more time.
      attr_accessor :can_re_register

      # @return [Integer] ContainerID represents the container.
      attr_accessor :container_id

      # @return [Integer] Number of items backed up in this container.
      attr_accessor :protected_item_count

      # @return [String] Agent version of this container.
      attr_accessor :agent_version

      # @return [MabContainerExtendedInfo] Additional information for this
      # container
      attr_accessor :extended_info

      # @return [Array<MABContainerHealthDetails>] Health details on this mab
      # container.
      attr_accessor :mab_container_health_details

      # @return [String] Health state of mab container.
      attr_accessor :container_health_state


      #
      # Mapper for MabContainer class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Windows',
          type: {
            name: 'Composite',
            class_name: 'MabContainer',
            model_properties: {
              friendly_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'friendlyName',
                type: {
                  name: 'String'
                }
              },
              backup_management_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'backupManagementType',
                type: {
                  name: 'String'
                }
              },
              registration_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'registrationStatus',
                type: {
                  name: 'String'
                }
              },
              health_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'healthStatus',
                type: {
                  name: 'String'
                }
              },
              containerType: {
                client_side_validation: true,
                required: true,
                serialized_name: 'containerType',
                type: {
                  name: 'String'
                }
              },
              can_re_register: {
                client_side_validation: true,
                required: false,
                serialized_name: 'canReRegister',
                type: {
                  name: 'Boolean'
                }
              },
              container_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'containerId',
                type: {
                  name: 'Number'
                }
              },
              protected_item_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'protectedItemCount',
                type: {
                  name: 'Number'
                }
              },
              agent_version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'agentVersion',
                type: {
                  name: 'String'
                }
              },
              extended_info: {
                client_side_validation: true,
                required: false,
                serialized_name: 'extendedInfo',
                type: {
                  name: 'Composite',
                  class_name: 'MabContainerExtendedInfo'
                }
              },
              mab_container_health_details: {
                client_side_validation: true,
                required: false,
                serialized_name: 'mabContainerHealthDetails',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'MABContainerHealthDetailsElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'MABContainerHealthDetails'
                      }
                  }
                }
              },
              container_health_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'containerHealthState',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
