# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2016_12_01
  module Models
    #
    # Pre-backup validation for Azure VM Workload provider.
    #
    class PreBackupValidation

      include MsRestAzure

      # @return [InquiryStatus] Status of protectable item, i.e.
      # InProgress,Succeeded,Failed. Possible values include: 'Invalid',
      # 'Success', 'Failed'
      attr_accessor :status

      # @return [String] Error code of protectable item
      attr_accessor :code

      # @return [String] Message corresponding to the error code for the
      # protectable item
      attr_accessor :message


      #
      # Mapper for PreBackupValidation class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'PreBackupValidation',
          type: {
            name: 'Composite',
            class_name: 'PreBackupValidation',
            model_properties: {
              status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'status',
                type: {
                  name: 'String'
                }
              },
              code: {
                client_side_validation: true,
                required: false,
                serialized_name: 'code',
                type: {
                  name: 'String'
                }
              },
              message: {
                client_side_validation: true,
                required: false,
                serialized_name: 'message',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
