# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2016_12_01
  module Models
    #
    # Details of an inquired protectable item.
    #
    class WorkloadInquiryDetails

      include MsRestAzure

      # @return [String] Type of the Workload such as SQL, Oracle etc.
      attr_accessor :type

      # @return [Integer] Contains the protectable item Count inside this
      # Container.
      attr_accessor :item_count

      # @return [InquiryValidation] Inquiry validation such as permissions and
      # other backup validations.
      attr_accessor :inquiry_validation


      #
      # Mapper for WorkloadInquiryDetails class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'WorkloadInquiryDetails',
          type: {
            name: 'Composite',
            class_name: 'WorkloadInquiryDetails',
            model_properties: {
              type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              item_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'itemCount',
                type: {
                  name: 'Number'
                }
              },
              inquiry_validation: {
                client_side_validation: true,
                required: false,
                serialized_name: 'inquiryValidation',
                type: {
                  name: 'Composite',
                  class_name: 'InquiryValidation'
                }
              }
            }
          }
        }
      end
    end
  end
end
