# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2017_07_01
  module Models
    #
    # AzureResource(IaaS VM) Specific feature support request
    #
    class AzureVMResourceFeatureSupportRequest < FeatureSupportRequest

      include MsRestAzure


      def initialize
        @featureType = "AzureVMResourceBackup"
      end

      attr_accessor :featureType

      # @return [String] Size of the resource: VM size(A/D series etc) in case
      # of IaasVM
      attr_accessor :vm_size

      # @return [String] SKUs (Premium/Managed etc) in case of IaasVM
      attr_accessor :vm_sku


      #
      # Mapper for AzureVMResourceFeatureSupportRequest class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AzureVMResourceBackup',
          type: {
            name: 'Composite',
            class_name: 'AzureVMResourceFeatureSupportRequest',
            model_properties: {
              featureType: {
                client_side_validation: true,
                required: true,
                serialized_name: 'featureType',
                type: {
                  name: 'String'
                }
              },
              vm_size: {
                client_side_validation: true,
                required: false,
                serialized_name: 'vmSize',
                type: {
                  name: 'String'
                }
              },
              vm_sku: {
                client_side_validation: true,
                required: false,
                serialized_name: 'vmSku',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
