# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2017_07_01
  module Models
    #
    # AzureWorkload SAP Hana-specific restore.
    #
    class AzureWorkloadSAPHanaRestoreRequest < RestoreRequest

      include MsRestAzure


      def initialize
        @objectType = "AzureWorkloadSAPHanaRestoreRequest"
      end

      attr_accessor :objectType

      # @return [TargetRestoreInfo] Details of target database
      attr_accessor :target_info

      # @return [RecoveryType] OLR/ALR, RestoreDisks is invalid option.
      # Possible values include: 'Invalid', 'OriginalLocation',
      # 'AlternateLocation', 'RestoreDisks'
      attr_accessor :recovery_type

      # @return [String] Fully qualified ARM ID of the VM on which workload
      # that was running is being recovered.
      attr_accessor :source_resource_id

      # @return [Hash{String => String}] Workload specific property bag.
      attr_accessor :property_bag


      #
      # Mapper for AzureWorkloadSAPHanaRestoreRequest class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AzureWorkloadSAPHanaRestoreRequest',
          type: {
            name: 'Composite',
            class_name: 'AzureWorkloadSAPHanaRestoreRequest',
            model_properties: {
              objectType: {
                client_side_validation: true,
                required: true,
                serialized_name: 'objectType',
                type: {
                  name: 'String'
                }
              },
              target_info: {
                client_side_validation: true,
                required: false,
                serialized_name: 'targetInfo',
                type: {
                  name: 'Composite',
                  class_name: 'TargetRestoreInfo'
                }
              },
              recovery_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'recoveryType',
                type: {
                  name: 'String'
                }
              },
              source_resource_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sourceResourceId',
                type: {
                  name: 'String'
                }
              },
              property_bag: {
                client_side_validation: true,
                required: false,
                serialized_name: 'propertyBag',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
