# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2017_07_01
  module Models
    #
    # BackupStatus response.
    #
    class BackupStatusResponse

      include MsRestAzure

      # @return [ProtectionStatus] Specifies whether the container is
      # registered or not. Possible values include: 'Invalid', 'NotProtected',
      # 'Protecting', 'Protected', 'ProtectionFailed'
      attr_accessor :protection_status

      # @return [String] Specifies the arm resource id of the vault
      attr_accessor :vault_id

      # @return [FabricName] Specifies the fabric name - Azure or AD. Possible
      # values include: 'Invalid', 'Azure'
      attr_accessor :fabric_name

      # @return [String] Specifies the product specific container name. E.g.
      # iaasvmcontainer;iaasvmcontainer;csname;vmname.
      attr_accessor :container_name

      # @return [String] Specifies the product specific ds name. E.g.
      # vm;iaasvmcontainer;csname;vmname.
      attr_accessor :protected_item_name

      # @return [String] ErrorCode in case of intent failed
      attr_accessor :error_code

      # @return [String] ErrorMessage in case of intent failed.
      attr_accessor :error_message

      # @return [String] Specifies the policy name which is used for protection
      attr_accessor :policy_name

      # @return [String] Container registration status
      attr_accessor :registration_status


      #
      # Mapper for BackupStatusResponse class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'BackupStatusResponse',
          type: {
            name: 'Composite',
            class_name: 'BackupStatusResponse',
            model_properties: {
              protection_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'protectionStatus',
                type: {
                  name: 'String'
                }
              },
              vault_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'vaultId',
                type: {
                  name: 'String'
                }
              },
              fabric_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'fabricName',
                type: {
                  name: 'String'
                }
              },
              container_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'containerName',
                type: {
                  name: 'String'
                }
              },
              protected_item_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'protectedItemName',
                type: {
                  name: 'String'
                }
              },
              error_code: {
                client_side_validation: true,
                required: false,
                serialized_name: 'errorCode',
                type: {
                  name: 'String'
                }
              },
              error_message: {
                client_side_validation: true,
                required: false,
                serialized_name: 'errorMessage',
                type: {
                  name: 'String'
                }
              },
              policy_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'policyName',
                type: {
                  name: 'String'
                }
              },
              registration_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'registrationStatus',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
