# encoding: utf-8
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::RecoveryServicesBackup::Mgmt::V2017_07_01
  module Models
    #
    # AzureRestoreValidation request.
    #
    class ValidateRestoreOperationRequest < ValidateOperationRequest

      include MsRestAzure


      def initialize
        @objectType = "ValidateRestoreOperationRequest"
      end

      attr_accessor :objectType

      # @return [RestoreRequest] Sets restore request to be validated
      attr_accessor :restore_request


      #
      # Mapper for ValidateRestoreOperationRequest class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ValidateRestoreOperationRequest',
          type: {
            name: 'Composite',
            class_name: 'ValidateRestoreOperationRequest',
            model_properties: {
              objectType: {
                client_side_validation: true,
                required: true,
                serialized_name: 'objectType',
                type: {
                  name: 'String'
                }
              },
              restore_request: {
                client_side_validation: true,
                required: false,
                serialized_name: 'restoreRequest',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'objectType',
                  uber_parent: 'RestoreRequest',
                  class_name: 'RestoreRequest'
                }
              }
            }
          }
        }
      end
    end
  end
end
